.\" Copyright (c) 2004 Daniel Hartmeier
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\"
.\"    - Redistributions of source code must retain the above copyright
.\"      notice, this list of conditions and the following disclaimer.
.\"    - Redistributions in binary form must reproduce the above
.\"      copyright notice, this list of conditions and the following
.\"      disclaimer in the documentation and/or other materials provided
.\"      with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
.\" "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
.\" LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
.\" FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
.\" COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
.\" BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
.\" LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
.\" CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
.\" ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.\" $NetBSD: cdce.4,v 1.4 2004/12/08 18:35:56 peter Exp $
.\"
.Dd October 22, 2004
.Dt CDCE 4
.Os
.Sh NAME
.Nm cdce
.Nd USB Communication Device Class Ethernet driver
.Sh SYNOPSIS
.Cd "cdce*  at uhub? port ?"
.Sh DESCRIPTION
The
.Nm
driver provides support for USB Host-to-Host (aka USB-to-USB) bridges
based on the USB Communication Device Class (CDC) and Ethernet subclass,
including the following:
.Pp
.Bl -bullet -compact
.It
Prolific PL-2501
.It
Sharp Zaurus
.El
.Pp
The USB bridge appears as a regular network interface on both sides,
transporting Ethernet frames.
.Pp
For more information on configuring this device, see
.Xr ifconfig 8 .
.Pp
USB 1.x bridges support speeds of up to 12Mbps, and USB 2.0 speeds of
up to 480Mbps.
.Pp
Packets are
received and transmitted over separate USB bulk transfer endpoints.
.Pp
The
.Nm
driver does not support different media types or options.
.Sh DIAGNOSTICS
.Bl -diag
.It "cdce%d: no union descriptor"
The driver couldn't fetch an interface descriptor from the USB
device.
For a manually added USB vendor/product, the CDCE_NO_UNION flag
can be tried to work around the missing descriptor.
.It "cdce%d: no data interface"
.It "cdce%d: could not read endpoint descriptor"
.It "cdce%d: unexpected endpoint"
.It "cdce%d: could not find data bulk in/out"
For a manually added USB vendor/product, these errors indicate
that the bridge is not compatible with the driver.
.It "cdce%d: watchdog timeout"
A packet was queued for transmission and a transmit command was
issued, however the device failed to acknowledge the transmission
before a timeout expired.
.It "cdce%d: no memory for rx list -- packet dropped!"
Memory allocation through MGETHDR or MCLGET failed, the system
is running low on mbufs.
.It "cdce%d: abort/close rx/tx pipe failed"
.It "cdce%d: rx/tx list init failed"
.It "cdce%d: open rx/tx pipe failed"
.It "cdce%d: usb error on rx/tx"
.El
.Sh SEE ALSO
.Xr arp 4 ,
.Xr intro 4 ,
.Xr netintro 4 ,
.Xr usb 4 ,
.\" .Xr hostname.if 5 ,
.Xr ifconfig 8
.Rs
.%T "Universal Serial Bus Class Definitions for Communication Devices"
.%O http://www.usb.org/developers/devclass_docs/usbcdc11.pdf
.Re
.Rs
.%T "Data sheet Prolific PL-2501 Host-to-Host Bridge/Network Controller"
.%O http://tech.prolific.com.tw/visitor/fcabdl.asp?fid=20679530
.Re
.Sh HISTORY
The
.Nm
device driver first appeared in
.Ox 3.6
and
.Nx 3.0 .
.Sh AUTHORS
.An -nosplit
The
.Nm
driver was written by
.An Craig Boston Aq craig@tobuj.gank.org
based on the
.Xr aue 4
driver written by
.An Bill Paul Aq wpaul@windriver.com
and ported to
.Ox
by
.An Daniel Hartmeier Aq dhartmei@openbsd.org .
.Sh CAVEATS
Many USB devices notoriously fail to report their class and interfaces
correctly.
Undetected products might work flawlessly when their vendor and product IDs
are added to the driver manually.
